/*******************************************************************************
 * AutoTestManager generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class AutoTestManager extends Info
    native
    config(Game)
    notplaceable
    hidecategories(Navigation,Movement,Collision);

var bool bAutomatedPerfTesting;
var bool bAutoContinueToNextRound;
var bool bUsingAutomatedTestingMapList;
var bool bAutomatedTestingWithOpen;
var globalconfig bool bExitOnCyclesComplete;
var bool bCheckingForFragmentation;
var bool bCheckingForMemLeaks;
var bool bIsDoingASimplePerfRun;
var bool bDoingASentinelRun;
var bool bSentinelRunInProgress;
var transient bool bSentinelStreamingLevelStillLoading;
var int AutomatedPerfRemainingTime;
var int AutomatedTestingMapIndex;
var globalconfig array<config string> AutomatedMapTestingList;
var globalconfig int NumAutomatedMapTestingCycles;
var int NumberOfMatchesPlayed;
var int NumMapListCyclesDone;
var string AutomatedTestingExecCommandToRunAtStartMatch;
var string AutomatedTestingExecCommandToRunAtStartMatchOnPC;
var string AutomatedMapTestingTransitionMap;
var string SentinelTaskDescription;
var string SentinelTaskParameter;
var string SentinelTagDesc;
var transient PlayerController SentinelPC;
var transient array<Vector> SentinelTravelArray;
var transient int SentinelNavigationIdx;
var transient int SentinelIdx;
var transient int NumRotationsIncrement;
var transient int TravelPointsIncrement;
var config int NumMinutesPerMap;
var int TotalNumMinutesToRun;
var float ProfilingInterval;
var config array<config string> CommandsToRunAtEachTravelTheWorldNode;
var transient string CommandStringToExec;

event PostBeginPlay()
{
    super(Actor).PostBeginPlay();
    SetTimer(1.0, true);
    //return;    
}

event Timer()
{
    // End:0x63
    if((bAutomatedPerfTesting && AutomatedPerfRemainingTime > 0) && !bAutoContinueToNextRound)
    {
        -- AutomatedPerfRemainingTime;
        // End:0x63
        if(AutomatedPerfRemainingTime <= 0)
        {
            ConsoleCommand("EXIT");
        }
    }
    //return;    
}

function InitializeOptions(string Options)
{
    local string InOpt;

    AutomatedPerfRemainingTime = 60 * WorldInfo.Game.TimeLimit;
    bAutomatedPerfTesting = (WorldInfo.Game.ParseOption(Options, "AutomatedPerfTesting") ~= "1") || WorldInfo.Game.ParseOption(Options, "gAPT") ~= "1";
    bCheckingForFragmentation = (WorldInfo.Game.ParseOption(Options, "CheckingForFragmentation") ~= "1") || WorldInfo.Game.ParseOption(Options, "gCFF") ~= "1";
    bCheckingForMemLeaks = (WorldInfo.Game.ParseOption(Options, "CheckingForMemLeaks") ~= "1") || WorldInfo.Game.ParseOption(Options, "gCFML") ~= "1";
    bIsDoingASimplePerfRun = WorldInfo.Game.ParseOption(Options, "SimplePerfRun") ~= "1";
    bDoingASentinelRun = (WorldInfo.Game.ParseOption(Options, "DoingASentinelRun") ~= "1") || WorldInfo.Game.ParseOption(Options, "gDASR") ~= "1";
    SentinelTaskDescription = WorldInfo.Game.ParseOption(Options, "SentinelTaskDescription");
    // End:0x41C
    if(SentinelTaskDescription == "")
    {
        SentinelTaskDescription = WorldInfo.Game.ParseOption(Options, "gSTD");
    }
    SentinelTaskParameter = WorldInfo.Game.ParseOption(Options, "SentinelTaskParameter");
    // End:0x4D7
    if(SentinelTaskParameter == "")
    {
        SentinelTaskParameter = WorldInfo.Game.ParseOption(Options, "gSTP");
    }
    SentinelTagDesc = WorldInfo.Game.ParseOption(Options, "SentinelTagDesc");
    // End:0x58D
    if(SentinelTagDesc == "")
    {
        SentinelTagDesc = WorldInfo.Game.ParseOption(Options, "gSTDD");
    }
    InOpt = WorldInfo.Game.ParseOption(Options, "AutoContinueToNextRound");
    // End:0x613
    if(InOpt != "")
    {
        bAutoContinueToNextRound = bool(InOpt);
    }
    InOpt = WorldInfo.Game.ParseOption(Options, "TotalNumMinutesToRun");
    // End:0x695
    if(InOpt != "")
    {
        TotalNumMinutesToRun = int(InOpt);
    }
    ProfilingInterval = 3.0;
    InOpt = WorldInfo.Game.ParseOption(Options, "ProfilingInterval");
    // End:0x723
    if(InOpt != "")
    {
        ProfilingInterval = float(InOpt);
    }
    InOpt = WorldInfo.Game.ParseOption(Options, "bUsingAutomatedTestingMapList");
    // End:0x7AF
    if(InOpt != "")
    {
        bUsingAutomatedTestingMapList = bool(InOpt);
    }
    // End:0x7D8
    if(bUsingAutomatedTestingMapList)
    {
        // End:0x7D8
        if(AutomatedMapTestingList.Length == 0)
        {
            bUsingAutomatedTestingMapList = false;
        }
    }
    InOpt = WorldInfo.Game.ParseOption(Options, "bAutomatedTestingWithOpen");
    // End:0x860
    if(InOpt != "")
    {
        bAutomatedTestingWithOpen = bool(InOpt);
    }
    AutomatedTestingExecCommandToRunAtStartMatch = WorldInfo.Game.ParseOption(Options, "AutomatedTestingExecCommandToRunAtStartMatch");
    AutomatedTestingExecCommandToRunAtStartMatchOnPC = WorldInfo.Game.ParseOption(Options, "AutomatedTestingExecCommandToRunAtStartMatchOnPC");
    AutomatedMapTestingTransitionMap = WorldInfo.Game.ParseOption(Options, "AutomatedMapTestingTransitionMap");
    InOpt = WorldInfo.Game.ParseOption(Options, "AutomatedTestingMapIndex");
    // End:0xA3D
    if(InOpt != "")
    {
        AutomatedTestingMapIndex = int(InOpt);
    }
    // End:0xB52
    if(bAutomatedTestingWithOpen)
    {
        InOpt = WorldInfo.Game.ParseOption(Options, "NumberOfMatchesPlayed");
        // End:0xACD
        if(InOpt != "")
        {
            NumberOfMatchesPlayed = int(InOpt);
        }
        InOpt = WorldInfo.Game.ParseOption(Options, "NumMapListCyclesDone");
        // End:0xB4F
        if(InOpt != "")
        {
            NumMapListCyclesDone = int(InOpt);
        }
    }
    // End:0xB5E
    else
    {
        AutomatedMapTestingTransitionMap = "";
    }
    //return;    
}

// Export UAutoTestManager::execBeginSentinelRun(FFrame&, void* const)
native function BeginSentinelRun(const string TaskDescription, const string TaskParameter, const string TagDesc);

// Export UAutoTestManager::execAddSentinelPerTimePeriodStats(FFrame&, void* const)
native function AddSentinelPerTimePeriodStats(const Vector InLocation, const Rotator InRotation);

// Export UAutoTestManager::execEndSentinelRun(FFrame&, void* const)
native function EndSentinelRun(Core.Object.EAutomatedRunResult RunResult);

function DoTravelTheWorld()
{
    GotoState('TravelTheWorld');
    //return;    
}

// Export UAutoTestManager::execDoSentinelActionPerLoadedMap(FFrame&, void* const)
native function DoSentinelActionPerLoadedMap();

// Export UAutoTestManager::execHandlePerLoadedMapAudioStats(FFrame&, void* const)
native function HandlePerLoadedMapAudioStats();

// Export UAutoTestManager::execGetTravelLocations(FFrame&, void* const)
native function GetTravelLocations(name LevelName, PlayerController PC, out array<Vector> TravelPoints);

// Export UAutoTestManager::execDoSentinel_MemoryAtSpecificLocation(FFrame&, void* const)
native function DoSentinel_MemoryAtSpecificLocation(const Vector InLocation, const Rotator InRotation);

// Export UAutoTestManager::execDoSentinel_PerfAtSpecificLocation(FFrame&, void* const)
native function DoSentinel_PerfAtSpecificLocation(const out Vector InLocation, const out Rotator InRotation);

// Export UAutoTestManager::execDoSentinel_ViewDependentMemoryAtSpecificLocation(FFrame&, void* const)
native function DoSentinel_ViewDependentMemoryAtSpecificLocation(const out Vector InLocation, const out Rotator InRotation);

function DoTimeBasedSentinelStatGathering()
{
    local PlayerController PC;
    local Vector ViewLocation;
    local Rotator ViewRotation;

    // End:0x23
    foreach LocalPlayerControllers(class'PlayerController', PC)
    {
        // End:0x23
        break;        
    }    
    PC.GetPlayerViewPoint(ViewLocation, ViewRotation);
    // End:0xF7
    if((SentinelTaskDescription != "FlyThrough") && SentinelTaskDescription != "FlyThroughSplitScreen")
    {
        // End:0xF7
        if(PC.Pawn != none)
        {
            ViewLocation = PC.Pawn.Location;
        }
    }
    AddSentinelPerTimePeriodStats(ViewLocation, ViewRotation);
    //return;    
}

function EndTimeBasedSentinelStatGatheringAndExit()
{
    ConsoleCommand("exit");
    //return;    
}

// Export UAutoTestManager::execDoMemoryTracking(FFrame&, void* const)
native function DoMemoryTracking();

event StartAutomatedMapTestTimer()
{
    SetTimer(5.0, true, 'StartAutomatedMapTestTimerWorker');
    //return;    
}

function StartAutomatedMapTestTimerWorker()
{
    local int LevelIdx;

    // End:0xB2
    if(WorldInfo != none)
    {
        LevelIdx = 0;
        J0x1A:
        // End:0x9B [Loop If]
        if(LevelIdx < WorldInfo.StreamingLevels.Length)
        {
            // End:0x8D
            if(WorldInfo.StreamingLevels[LevelIdx].bHasLoadRequestPending == true)
            {
                return;
            }
            ++ LevelIdx;
            // [Loop Continue]
            goto J0x1A;
        }
        // End:0xB2
        if(bCheckingForMemLeaks)
        {
            DoMemoryTracking();
        }
    }
    ClearTimer('StartAutomatedMapTestTimerWorker');
    SetTimer(15.0, false, 'CloseAutomatedMapTestTimer');
    //return;    
}

function CloseAutomatedMapTestTimer()
{
    // End:0x57
    if(Len(AutomatedMapTestingTransitionMap) > 0)
    {
        // End:0x54
        if(AutomatedTestingMapIndex < 0)
        {
            WorldInfo.Game.RestartGame();
        }
    }
    // End:0x8B
    else
    {
        WorldInfo.Game.RestartGame();
    }
    //return;    
}

function IncrementAutomatedTestingMapIndex()
{
    // End:0x3D
    if(bUsingAutomatedTestingMapList == true)
    {
        // End:0x23
        if(bAutomatedTestingWithOpen == true)
        {
        }
        // End:0x3D
        else
        {
            // End:0x3D
            if(AutomatedTestingMapIndex >= 0)
            {
                ++ AutomatedTestingMapIndex;
            }
        }
    }
    //return;    
}

function IncrementNumberOfMatchesPlayed()
{
    ++ NumberOfMatchesPlayed;
    //return;    
}

function string GetNextAutomatedTestingMap()
{
    local string MapName;
    local PlayerController PC;
    local bool bResetMapIndex;

    // End:0x2E7
    if(bUsingAutomatedTestingMapList)
    {
        // End:0x62
        if((AutomatedTestingMapIndex >= 0) && Len(AutomatedMapTestingTransitionMap) > 0)
        {
            ++ AutomatedTestingMapIndex;
            AutomatedTestingMapIndex *= float(-1);
            MapName = AutomatedMapTestingTransitionMap;
        }
        // End:0xDC
        else
        {
            // End:0x85
            if(Len(AutomatedMapTestingTransitionMap) > 0)
            {
                AutomatedTestingMapIndex *= float(-1);
            }
            // End:0xBF
            if(AutomatedTestingMapIndex >= AutomatedMapTestingList.Length)
            {
                AutomatedTestingMapIndex = 0;
                ++ NumMapListCyclesDone;
                bResetMapIndex = true;
            }
            MapName = AutomatedMapTestingList[AutomatedTestingMapIndex];
        }
        // End:0x182
        if(bAutomatedTestingWithOpen == true)
        {
            // End:0x17F
            if((NumMapListCyclesDone >= NumAutomatedMapTestingCycles) && NumAutomatedMapTestingCycles != 0)
            {
                // End:0x158
                if(bCheckingForMemLeaks)
                {
                    ConsoleCommand("DEFERRED_STOPMEMTRACKING_AND_DUMP");
                }
                // End:0x17F
                if(bExitOnCyclesComplete)
                {
                    ConsoleCommand("EXIT");
                }
            }
        }
        // End:0x2DD
        else
        {
            // End:0x2DC
            foreach WorldInfo.AllControllers(class'PlayerController', PC)
            {
                // End:0x20B
                if(bResetMapIndex)
                {
                    ++ PC.PlayerReplicationInfo.AutomatedTestingData.NumMapListCyclesDone;
                }
                // End:0x2DB
                if((PC.PlayerReplicationInfo.AutomatedTestingData.NumMapListCyclesDone >= NumAutomatedMapTestingCycles) && NumAutomatedMapTestingCycles != 0)
                {
                    // End:0x2B4
                    if(bCheckingForMemLeaks)
                    {
                        ConsoleCommand("DEFERRED_STOPMEMTRACKING_AND_DUMP");
                    }
                    // End:0x2DB
                    if(bExitOnCyclesComplete)
                    {
                        ConsoleCommand("EXIT");
                    }
                }                
            }            
        }
        return MapName;
    }
    return "";
    //return ReturnValue;    
}

function StartMatch()
{
    local PlayerController PC;

    // End:0x1A
    if(bAutomatedTestingWithOpen)
    {
        IncrementNumberOfMatchesPlayed();
    }
    // End:0x72
    else
    {
        // End:0x71
        foreach WorldInfo.AllControllers(class'PlayerController', PC)
        {
            PC.IncrementNumberOfMatchesPlayed();
            // End:0x71
            break;            
        }        
    }
    IncrementAutomatedTestingMapIndex();
    // End:0xAB
    if(bCheckingForFragmentation)
    {
        ConsoleCommand("MemFragCheck");
    }
    // End:0xD8
    if(AutomatedTestingExecCommandToRunAtStartMatch != "")
    {
        ConsoleCommand(AutomatedTestingExecCommandToRunAtStartMatch);
    }
    //return;    
}

function bool CheckForSentinelRun()
{
    // End:0x9C
    if(bDoingASentinelRun)
    {
        // End:0x64
        if(SentinelTaskDescription ~= "TravelTheWorld")
        {
            WorldInfo.Game.DoTravelTheWorld();
            return true;
        }
        // End:0x9C
        else
        {
            BeginSentinelRun(SentinelTaskDescription, SentinelTaskParameter, SentinelTagDesc);
            SetTimer(3.0, true, 'DoTimeBasedSentinelStatGathering');
        }
    }
    return false;
    //return ReturnValue;    
}

state TravelTheWorld
{
    ignores PrintOutTravelWorldTimes;

    function BeginState(name PreviousStateName)
    {
        local PlayerController PC;

        super(Object).BeginState(PreviousStateName);
        // End:0x68
        foreach LocalPlayerControllers(class'PlayerController', PC)
        {
            SentinelPC = PC;
            SentinelPC.Sentinel_SetupForGamebasedTravelTheWorld();
            // End:0x68
            break;            
        }        
        SentinelPC.bIsUsingStreamingVolumes = false;
        BeginSentinelRun(SentinelTaskDescription, SentinelTaskParameter, SentinelTagDesc);
        //return;        
    }

    function float CalcTravelTheWorldTime(const int NumTravelLocations, const int NumRotations)
    {
        local float TotalTimeInSeconds, PerTravelLocTime;

        TotalTimeInSeconds += (float(WorldInfo.StreamingLevels.Length) * 2.0);
        TotalTimeInSeconds += 10.0;
        TotalTimeInSeconds += (float(WorldInfo.StreamingLevels.Length) * 10.0);
        TotalTimeInSeconds += 10.0;
        TotalTimeInSeconds += 10.0;
        PerTravelLocTime = (((((0.50 + 4.0) + 1.0) + 0.50) + 1.0) + (float(NumRotations) * 1.50)) + (float(NumRotations) * 1.50);
        TotalTimeInSeconds += (PerTravelLocTime * float(NumTravelLocations));
        return TotalTimeInSeconds;
        //return ReturnValue;        
    }

    function SetIncrementsForLoops(const float NumTravelLocations)
    {
        local float TimeWeGetInSeconds;

        TimeWeGetInSeconds = float(NumMinutesPerMap * 60);
        // End:0x7A
        if((CalcTravelTheWorldTime(int(NumTravelLocations), 8)) < TimeWeGetInSeconds)
        {
            TravelPointsIncrement = 1;
            NumRotationsIncrement = 1;
            PrintOutTravelWorldTimes(int(CalcTravelTheWorldTime(int(NumTravelLocations), 8)));
        }
        // End:0x146
        else
        {
            // End:0xDC
            if((CalcTravelTheWorldTime(int(NumTravelLocations), 4)) < TimeWeGetInSeconds)
            {
                TravelPointsIncrement = 1;
                NumRotationsIncrement = 2;
                PrintOutTravelWorldTimes(int(CalcTravelTheWorldTime(int(NumTravelLocations), 4)));
            }
            // End:0x146
            else
            {
                TravelPointsIncrement = int((CalcTravelTheWorldTime(int(NumTravelLocations), 4)) / TimeWeGetInSeconds);
                NumRotationsIncrement = 2;
                PrintOutTravelWorldTimes(int(CalcTravelTheWorldTime(int(NumTravelLocations / float(TravelPointsIncrement)), 4)));
            }
        }
        //return;        
    }

Begin:
    SentinelPC.Sentinel_PreAcquireTravelTheWorldPoints();
    SentinelIdx = 0;
    J0x2A:
    // End:0xC4 [Loop If]
    if(SentinelIdx < WorldInfo.StreamingLevels.Length)
    {
        SentinelPC.ClientUpdateLevelStreamingStatus(WorldInfo.StreamingLevels[SentinelIdx].PackageName, false, false, true);
        ++ SentinelIdx;
        // [Loop Continue]
        goto J0x2A;
    }
    Sleep(10.0);
    WorldInfo.ForceGarbageCollection(true);
    SentinelIdx = 0;
    J0xF7:
    // End:0x36C [Loop If]
    if(SentinelIdx < WorldInfo.StreamingLevels.Length)
    {
        SentinelPC.ClientUpdateLevelStreamingStatus(WorldInfo.StreamingLevels[SentinelIdx].PackageName, true, true, true);
        Sleep(7.0);
        GetTravelLocations(WorldInfo.StreamingLevels[SentinelIdx].PackageName, SentinelPC, SentinelTravelArray);
        DoSentinelActionPerLoadedMap();
        SentinelPC.ConsoleCommand("FractureAllMeshesToMaximizeMemoryUsage");
        SentinelPC.ConsoleCommand("stat memory");
        Sleep(0.50);
        DoSentinel_MemoryAtSpecificLocation(vect(0.0, 0.0, 0.0), rot(0, 0, 0));
        SentinelPC.ConsoleCommand("stat memory");
        SentinelPC.ClientUpdateLevelStreamingStatus(WorldInfo.StreamingLevels[SentinelIdx].PackageName, false, false, true);
        Sleep(3.0);
        WorldInfo.ForceGarbageCollection(true);
        ++ SentinelIdx;
        // [Loop Continue]
        goto J0xF7;
    }
    // End:0x505
    if(WorldInfo.StreamingLevels.Length == 0)
    {
        GetTravelLocations(WorldInfo.StreamingLevels[SentinelIdx].PackageName, SentinelPC, SentinelTravelArray);
        DoSentinelActionPerLoadedMap();
        SentinelPC.ConsoleCommand("FractureAllMeshesToMaximizeMemoryUsage");
        SentinelPC.ConsoleCommand("stat memory");
        Sleep(0.50);
        DoSentinel_MemoryAtSpecificLocation(vect(0.0, 0.0, 0.0), rot(0, 0, 0));
        SentinelPC.ConsoleCommand("stat memory");
        Sleep(3.0);
        WorldInfo.ForceGarbageCollection(true);
    }
    SetIncrementsForLoops(float(SentinelTravelArray.Length));
    SentinelIdx = 0;
    J0x526:
    // End:0x5F7 [Loop If]
    if(SentinelIdx < WorldInfo.StreamingLevels.Length)
    {
        // End:0x5E9
        if(LevelStreamingAlwaysLoaded(WorldInfo.StreamingLevels[SentinelIdx]) != none)
        {
            SentinelPC.ClientUpdateLevelStreamingStatus(WorldInfo.StreamingLevels[SentinelIdx].PackageName, true, true, true);
        }
        ++ SentinelIdx;
        // [Loop Continue]
        goto J0x526;
    }
    SentinelPC.bIsUsingStreamingVolumes = true;
    Sleep(10.0);
    SentinelPC.Sentinel_PostAcquireTravelTheWorldPoints();
    Sleep(10.0);
    SentinelTravelArray.AddItem(SentinelTravelArray[0]);
    SentinelNavigationIdx = 0;
    J0x66A:
    // End:0xB61 [Loop If]
    if(SentinelNavigationIdx < SentinelTravelArray.Length)
    {
        SentinelPC.SetLocation(SentinelTravelArray[SentinelNavigationIdx]);
        SentinelPC.SetRotation(rot(0, 0, 0));
        Sleep(0.50);
        bSentinelStreamingLevelStillLoading = false;
        SentinelIdx = 0;
        J0x6F1:
        // End:0x787 [Loop If]
        if(SentinelIdx < WorldInfo.StreamingLevels.Length)
        {
            // End:0x779
            if(WorldInfo.StreamingLevels[SentinelIdx].bHasLoadRequestPending == true)
            {
                bSentinelStreamingLevelStillLoading = true;
                Sleep(1.0);
                // [Explicit Break]
                goto J0x787;
            }
            ++ SentinelIdx;
            J0x787:
            // [Loop Continue]
            goto J0x6F1;
        }
        // End:0x6DA
        if(bSentinelStreamingLevelStillLoading == false)
            goto J0x6DA;
        WorldInfo.ForceGarbageCollection(true);
        Sleep(1.0);
        // End:0x7F0
        if(SentinelNavigationIdx == 0)
        {
            ConsoleCommand("MemLeakCheck");
        }
        SentinelPC.ConsoleCommand("stat memory");
        Sleep(0.50);
        DoSentinel_MemoryAtSpecificLocation(SentinelPC.Location, SentinelPC.Rotation);
        SentinelPC.ConsoleCommand("stat memory");
        SentinelPC.ConsoleCommand("stat scenerendering");
        SentinelPC.ConsoleCommand("stat streaming");
        Sleep(1.0);
        SentinelIdx = 0;
        J0x934:
        // End:0x9E3 [Loop If]
        if(SentinelIdx < 8)
        {
            SentinelPC.SetRotation(rot(0, 1, 0) * float(8192 * SentinelIdx));
            Sleep(1.50);
            DoSentinel_ViewDependentMemoryAtSpecificLocation(SentinelPC.Location, SentinelPC.Rotation);
            SentinelIdx += NumRotationsIncrement;
            // [Loop Continue]
            goto J0x934;
        }
        SentinelPC.ConsoleCommand("stat scenerendering");
        SentinelPC.ConsoleCommand("stat streaming");
        SentinelIdx = 0;
        J0xA65:
        // End:0xB14 [Loop If]
        if(SentinelIdx < 8)
        {
            SentinelPC.SetRotation(rot(0, 1, 0) * float(8192 * SentinelIdx));
            Sleep(1.50);
            DoSentinel_PerfAtSpecificLocation(SentinelPC.Location, SentinelPC.Rotation);
            SentinelIdx += NumRotationsIncrement;
            // [Loop Continue]
            goto J0xA65;
        }
        // End:0xB49
        foreach CommandsToRunAtEachTravelTheWorldNode(CommandStringToExec,)
        {
            ConsoleCommand(CommandStringToExec);            
        }        
        SentinelNavigationIdx += TravelPointsIncrement;
        // [Loop Continue]
        goto J0x66A;
    }
    ConsoleCommand("MemLeakCheck");
    ConsoleCommand("exit");
    stop;            
}

state SentinelHandleCauseEventCommand
{
Begin:
    bSentinelStreamingLevelStillLoading = false;
    SentinelIdx = 0;
    J0x17:
    // End:0xAD [Loop If]
    if(SentinelIdx < WorldInfo.StreamingLevels.Length)
    {
        // End:0x9F
        if(WorldInfo.StreamingLevels[SentinelIdx].bHasLoadRequestPending == true)
        {
            bSentinelStreamingLevelStillLoading = true;
            Sleep(1.0);
            // [Explicit Break]
            goto J0xAD;
        }
        ++ SentinelIdx;
        J0xAD:
        // [Loop Continue]
        goto J0x17;
    }
    // End:0x00
    if(bSentinelStreamingLevelStillLoading == false)
        goto J0x00;
    // End:0x193
    if(WorldInfo.Game.CauseEventCommand != "")
    {
        // End:0x192
        foreach WorldInfo.AllControllers(class'PlayerController', SentinelPC)
        {
            SentinelPC.ConsoleCommand("ce " $ WorldInfo.Game.CauseEventCommand);
            // End:0x192
            break;            
        }        
    }
    // End:0x1E7
    if((SentinelTaskDescription == "FlyThrough") || SentinelTaskDescription == "FlyThroughSplitScreen")
    {
        SetTimer(0.50, true, 'DoTimeBasedSentinelStatGathering');
    }
    stop;                    
}

defaultproperties
{
    NumMinutesPerMap=50
}